"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantConsequence(ProtocolElement):
    """
    A variant consequence as defined by the Sequence Ontology (SO) (e.g.:
    id = SO:0001816 ; name = non synonymous) NOTE: this record is
    equivalent to OpenCB's `ConsequenceType`, but we want to avoid
    naming collisions
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.VariantConsequence": reports_6_9_0.VariantConsequence,
        }

    __slots__ = [
        "id",
        "name",
    ]

    def __init__(
        self,
        id,
        name=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.VariantConsequence model.

        :param id:
            The SO term identifier (e.g.: SO:0001816)
        :type id: str
        :param name:
            The SO term name (e.g.: non synonymous)
        :type name: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
